/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_GL_UTIL
#define _H_F3_GL_UTIL

#include "fe_util.hpp"

#if defined(__APPLE__) && defined(__MACH__)
#include <OpenGL/gl.h>	// Header File For The OpenGL32 Library
#include <OpenGL/glu.h>	// Header File For The GLu32 Library
//#include <OpenGL/glext.h>
#else
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <GL/glext.h>
#endif

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

using namespace std;


// TODO: Find out if we really need this:
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

// And this
// This will cause problems somewhere
#ifndef GL_BGR
#define GL_BGR GL_BGR_EXT
#endif

#if (GL_GLEXT_VERSION >= 26) && defined(WIN32)
extern PFNGLBINDBUFFERARBPROC pglBindBufferARB;
extern PFNGLGENBUFFERSARBPROC pglGenBuffersARB;
extern PFNGLBUFFERDATAARBPROC pglBufferDataARB;
extern PFNGLLOCKARRAYSEXTPROC	glLockArraysEXT;
extern PFNGLUNLOCKARRAYSEXTPROC	glUnlockArraysEXT;
#else
#undef GL_EXT_compiled_vertex_array
#endif

const float Pi = (float)3.1415; //acos(-1);
struct xyz {
	float x, y, z;
};

const float TWOPI = 2*Pi;
const float PID2 = 1.5;

class GLUtil
{
public:	

	GLUtil() { font64 = NULL; font25 = NULL; font30 = NULL; };
	~GLUtil();

	SDL_Surface* createTextSurfaceGL(const char* text);
	SDL_Surface* createTextSurfaceGL(int number);
	SDL_Surface* createTextSurfaceGL(const char* text, int w, int h, int point, bool xCenter );
	SDL_Surface* flipSurfaceNew(SDL_Surface *sin, bool hor, bool ver);
	SDL_Surface *flipSurface(SDL_Surface *sin, bool hor, bool ver);
	SDL_Surface *LoadBMP(const char *filename, bool hor, bool ver);

	TTF_Font* openFont(string fontname, int point);

	string m_FontFile;


private:
    TTF_Font *font64;
    TTF_Font *font25;
    TTF_Font *font30;


};
#endif // _H_F3_GL_UTIL
