/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

/**
	Note: this is really ugly and sloppy, and should and will be re-written with something SAXish
	or possibly libxmlish. 
  */


#include "nmap_p.hpp"


bool NmapParser::isUsable(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument* doc)
{
	XMLCh* tmpCh = NULL;
//	char *sname = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* xmlNodes = NULL;

	tmpCh = XMLString::transcode("nmaprun");
	xmlNodes  = doc->getElementsByTagName(tmpCh);
	delete tmpCh;
	
	if((xmlNodes == NULL) || (xmlNodes->getLength() <= 0))
		return FALSE;
	
	m_xmlDoc = doc;

	return TRUE;
}

bool NmapParser::Parse()
{
	XMLCh* tmpCh = NULL;
	int nodeCount = 0;
	
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* xmlNodes = NULL;
	
	if(m_xmlDoc == NULL)
		return FALSE;

	tmpCh = XMLString::transcode("host");
	xmlNodes  = m_xmlDoc->getElementsByTagName(tmpCh);
	delete tmpCh;

	if(xmlNodes == NULL)
		return FALSE;

	FeNode* scanNodes = new FeNode();
	scanNodes->m_Config = this->m_Config;

	nodeCount = xmlNodes->getLength();

	// Parse all the host nodes.
	for(int i = 0; i < nodeCount; ++i)
	{
		scanNodes->addHost(parseHost(xmlNodes->item(i)));
	}

	m_Scan->addNode(scanNodes);
	return TRUE;
}

HostDraw* NmapParser::parseHost(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node)
{
	HostDraw* tmpHost = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* xmlChildNodes = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlTempNode = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlSubNode = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap* xmlAtt = NULL;

	char *sname = NULL;
	XMLCh* tmpCh = NULL;

	if(node == NULL)
		return tmpHost;

	tmpHost = new HostDraw();

	tmpHost->m_Config = m_Scan->m_Config;
	tmpHost->m_TexStore = m_Scan->m_TexStore;
	
	xmlChildNodes = node->getChildNodes();

	if(!xmlChildNodes)
		return tmpHost;

	for(unsigned int i = 0; i < xmlChildNodes->getLength(); ++i)
	{
		xmlTempNode = xmlChildNodes->item(i);
		
		if(xmlTempNode == NULL)
			break;

		sname = XMLString::transcode(xmlTempNode->getNodeName());

		if (strcmp(sname, "status") == 0)
		{
			xmlAtt = xmlTempNode->getAttributes();

			// Get the attributes
			if(xmlAtt != NULL)
			{
				tmpCh = XMLString::transcode("state");
				xmlSubNode = xmlAtt->getNamedItem(tmpCh);
				if(xmlSubNode)
				{
					delete sname;
					sname = XMLString::transcode(xmlSubNode->getNodeValue());
				}
				else
				{
					continue;
				}
				delete tmpCh;
			}

			if(strcmp(sname, "up") != 0) // Host is down.
			{
				delete sname;
				delete tmpHost;
				return NULL;
			}
		}
		else if (strcmp(sname, "address") == 0)
		{
			parseAddress(xmlTempNode, tmpHost);
		}
		else if (strcmp(sname, "hostnames") == 0)
		{
		// parseHostnames(xmlTempNode, tmpHost);
		}
		else if (strcmp(sname, "ports") == 0)
		{
			parsePorts(xmlTempNode, tmpHost);
		}
		else if (strcmp(sname, "os") == 0)
		{
			parseOS(xmlTempNode, tmpHost);
		}
		else if (strcmp(sname, "uptime") == 0)
		{

		}
		else if (strcmp(sname, "tcpsequence") == 0)
		{

		}
		else if (strcmp(sname, "ipidsequence") == 0)
		{

		}
		else if (strcmp(sname, "tcptssequence") == 0)
		{

		}
		delete sname;
	}

	return tmpHost;
}

void NmapParser::parsePorts(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node, HostDraw* host)
{
	
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* xmlChildNodes = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlTempNode = NULL;

	char *sname = NULL;
	//XMLCh* tmpCh = NULL;

	xmlChildNodes = node->getChildNodes();

	if(!xmlChildNodes)
		return;

	for(unsigned int i = 0; i < xmlChildNodes->getLength(); ++i)
	{
		xmlTempNode = xmlChildNodes->item(i);
		
		if(xmlTempNode == NULL)
			break;

		sname = XMLString::transcode(xmlTempNode->getNodeName());

		if (strcmp(sname, "port") == 0)
		{
			host->addPort(parsePort(xmlTempNode));
		}
		delete sname;
	}

}



/**
 * \todo Re-write
 */
PortDraw* NmapParser::parsePort(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node)
{

	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlTempNode = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap* xmlAtt = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlSubNode = NULL;

	XMLCh* tmpCh = NULL;
	char *sname = NULL;
	char *sname2 = NULL;

	PortDraw* tmpPort = NULL;

	STATE st = 0;
	int port = 0;
	PROTOCOL prt = PortDraw::PROT_TCP;

	xmlTempNode = node->getFirstChild();
	xmlAtt = node->getAttributes();
						
	// Get the attributes
	if(xmlAtt != NULL)
	{
		tmpCh = XMLString::transcode("portid");
		xmlSubNode = xmlAtt->getNamedItem(tmpCh);

		if(!xmlSubNode)
			return NULL;

		sname = XMLString::transcode(xmlSubNode->getNodeValue());
		port = atoi(sname);
		delete sname;
		delete tmpCh;

	} // if(xmlAtt != NULL)

	while(xmlTempNode != NULL)
	{
		// Get Attributes
		sname = XMLString::transcode(xmlTempNode->getNodeName());
					
		if(strcmp(sname, "state")==0)
		{
			xmlAtt = xmlTempNode->getAttributes();
			
			if(xmlAtt == NULL)
				continue;
			
			tmpCh = XMLString::transcode("state");
			xmlSubNode = xmlAtt->getNamedItem(tmpCh);
			delete tmpCh;

			if(xmlTempNode == NULL)
				continue;
	
			delete sname;
			sname = XMLString::transcode(xmlSubNode->getNodeValue());
					
			if(strcmp(sname, "open")==0)
			{
				st = PortDraw::STATE_OPEN;
			}
			else if(strcmp(sname, "filtered")==0)
			{
				st = PortDraw::STATE_FILTERED;
			}
			else //if(strcmp(sname, "closed")==0)
			{
				st = PortDraw::STATE_CLOSED;
			}
		}
		else if(strcmp(sname, "service")==0)
		{
			xmlAtt = xmlTempNode->getAttributes();
			if(xmlAtt == NULL)
				continue;
			
			tmpCh = XMLString::transcode("name");
			xmlSubNode = xmlAtt->getNamedItem(tmpCh);
			delete tmpCh;

			if(xmlSubNode)
			{
	            sname2 = XMLString::transcode(xmlSubNode->getNodeValue());
			}
		}

		delete sname;

		xmlTempNode = xmlTempNode->getNextSibling();

	} // while(xmlTempNode2 != NULL)

	tmpPort = new PortDraw(port, st, prt);
	tmpPort->m_Config = this->m_Config;
	tmpPort->m_TexStore = m_Config->getTextureStore();

	tmpPort->setService(sname2);
	delete sname2;
	return tmpPort;
}

/**
 * \todo Re-write
 */
void NmapParser::parseAddress(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node, HostDraw* host)
{
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlSubNode = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap* xmlAtt = NULL;
	xmlAtt = node->getAttributes();
	XMLCh* tmpCh = NULL;

	char *sname = NULL;

	// Get the attributes
	if(xmlAtt != NULL)
	{
		tmpCh = XMLString::transcode("addr");
		xmlSubNode = xmlAtt->getNamedItem(tmpCh);
		sname = XMLString::transcode(xmlSubNode->getNodeValue());
		host->setIp(sname);
		delete tmpCh;
		delete sname;
	}
}

/**
 * \todo Re-write
 */
void NmapParser::parseOS(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node, HostDraw* host)
{
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlSubNode = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap* xmlAtt = NULL;
	XMLCh* tmpCh = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* osNodes = NULL;
	char *sname = NULL;

	if(node == NULL)
	{
		return;
	}
	
	osNodes = node->getChildNodes();

	for(unsigned int i = 0; i < osNodes->getLength(); ++i)
	{
		sname = XMLString::transcode(osNodes->item(i)->getNodeName());
		if (strcmp(sname, "osclass")==0)
		{
			node = osNodes->item(i);
		}
		delete sname;

	} // for(unsigned int i = 0; i < portNodes->getLength(); ++i)
	
	xmlAtt = node->getAttributes();
						
	// Get the attributes
	if(xmlAtt != NULL)
	{
		tmpCh = XMLString::transcode("type");
		xmlSubNode = xmlAtt->getNamedItem(tmpCh);
		if(xmlSubNode)
		{
			sname = XMLString::transcode(xmlSubNode->getNodeValue());
			host->setType(sname);
			delete sname;
		}
		delete tmpCh;
        
		tmpCh = XMLString::transcode("vendor");
		xmlSubNode = xmlAtt->getNamedItem(tmpCh);

		if(xmlSubNode)
		{
			sname = XMLString::transcode(xmlSubNode->getNodeValue());
			host->setVendor(sname);
			delete sname;
		}
		delete tmpCh;

		tmpCh = XMLString::transcode("osfamily");
		xmlSubNode = xmlAtt->getNamedItem(tmpCh);
		
		if(xmlSubNode)
		{
			sname = XMLString::transcode(xmlSubNode->getNodeValue());
			host->setOSFam(m_Config->getFamily(sname));
			delete sname;
		}
		delete tmpCh;

		tmpCh = XMLString::transcode("osgen");
		xmlSubNode = xmlAtt->getNamedItem(tmpCh);
		if(xmlSubNode)
		{
			sname = XMLString::transcode(xmlSubNode->getNodeValue());
			delete sname;
		}

		delete tmpCh;
	} // if(xmlAtt != NULL)

}
